unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SGSDBManager, ComCtrls, Buttons, ExtCtrls, FileCtrl,inifiles;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    SGSDBManager1: TSGSDBManager;
    Panel1: TPanel;
    Label4: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    Label1: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label6: TLabel;
    Edit2: TEdit;
    SpeedButton2: TSpeedButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Label7: TLabel;
    Edit3: TEdit;
    SpeedButton3: TSpeedButton;
    CheckBox2: TCheckBox;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SGSDBManager1BackupFile(Sender: TObject; FileName: String;
      TotalFiles, CurrentFile: Integer);
    procedure SGSDBManager1ProcessTable(Sender: TObject; TableName: String;
      TotalTables, CurrentTable: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenDialog1Show(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FlagControl:Integer;
    inifile:TInifile;
    procedure ReadIniFile;
    procedure WriteIniFile;

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WriteIniFile;
begin
  IniFile.WriteString('Directory', 'DATABASE', Edit1.text);
  IniFile.WriteString('Directory', 'BACKUP', Edit3.text);
  IniFile.WriteString('DIC', 'FileName', Edit2.text);
end;

procedure TForm1.ReadIniFile;
begin
  IniFile  := TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI'));

  Edit1.Text:= IniFile.ReadString('Directory', 'DATABASE', ExtractFilePath(Application.ExeName));
  Edit3.Text:= IniFile.ReadString('Directory', 'BACKUP', ExtractFilePath(Application.ExeName)+'TEMP');
  Edit2.Text:= IniFile.ReadString('DIC', 'FileName', ExtractFilePath(Application.ExeName)+'db.dic');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
sgsdbmanager1.createdictionary;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Panel1.Visible:=True;
sgsdbmanager1.createdatabase;
Panel1.Visible:=False;
end;


procedure TForm1.SGSDBManager1BackupFile(Sender: TObject; FileName: String;
  TotalFiles, CurrentFile: Integer);
begin
label3.Caption:=FileName;
label4.Caption:=IntToStr(CurrentFile)+'/'+IntToStr(TotalFiles);
ProgressBar2.Max:=TotalFiles;
ProgressBar2.Position:=CurrentFile;
Update;
end;

procedure TForm1.SGSDBManager1ProcessTable(Sender: TObject;
  TableName: String; TotalTables, CurrentTable: Integer);
begin
label1.Caption:=TableName;
label2.Caption:=IntToStr(CurrentTable)+'/'+IntToStr(TotalTables);
ProgressBar1.Max:=TotalTables;
ProgressBar1.Position:=CurrentTable;
Update;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
temp:string;
begin
SelectDirectory(Temp, [sdAllowCreate,sdPerformCreate], Self.HelpContext);
Edit1.Text:=Temp;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
temp:string;
begin
SelectDirectory(Temp, [sdAllowCreate,sdPerformCreate], Self.HelpContext);
Edit3.Text:=Temp;

end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
SGSDBManager1.DBName:=Edit1.Text;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
SGSDBManager1.Dictionary:=Edit2.text;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
SGSDBManager1.BackupDir:=Edit3.text;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
SGSDBManager1.DeleteIndex:=CheckBox2.Checked;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
SGSDBManager1.CreateBackup:=CheckBox1.Checked;
if CheckBox1.Checked then
   begin
   Edit3.Visible:=True;
   Label7.Enabled:=True;
   SpeedButton3.Enabled:=True;
   end
else
   begin
   Edit3.Visible:=False;
   Label7.Enabled:=False;
   SpeedButton3.Enabled:=False;
   end;

end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
if OpenDialog1.Execute then
   Edit2.Text:=OpenDialog1.Filename;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
ReadIniFile;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
WriteIniFile;
end;

procedure TForm1.OpenDialog1Show(Sender: TObject);
begin
OpenDialog1.InitialDir:=(ExtractFilePath(Edit2.Text));
OpenDialog1.FileName:=Edit2.Text;
end;

end.
